/* This file is part of AHD ID3 Tag Editor (AITE)
   A program can create and edit ID3 Tag for mp3 files

   Copyright © Ala I.Hadid 2012

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AHD.ID3Tag.TextFrames
{
    public class TKEY : TextFrame
    {
        public TKEY()
            : base("TKEY", 0, 0, null)
        { }
        public TKEY(int size, ushort flags, byte[] data)
            : base("TKEY", size, flags, data)
        { }

        public override string Name
        {
            get { return "Initial key"; }
        }
        public override string Text
        {
            get
            {
                string text = base.Text;
                if (text == "o")
                {
                    text = text.Replace("o", "off key");
                }
                else
                {
                    text = text.Replace("#", " sharp");
                    text = text.Replace("b", " flat");
                    text = text.Replace("m", " (minor)");
                }
                return text;
            }
            set
            {
                string text = value.Replace(" ", "");
                text = text.Replace("sharp", "#");
                text = text.Replace("flat", "b");
                text = text.Replace("(minor)", "m");
                text = text.Replace("offkey", "o");
                base.Text = text;
            }
        }
        public override TextFrameType FrameType
        {
            get
            {
                return TextFrameType.TypeOfTypesNotEditable;
            }
        }
    }
}
